/**
 * Various constants used in STM.
 *
 * @author Aleksandar Dragojevic aleksandar.dragojevic
 */

#ifndef SWISSTM_CONSTANTS_H_
#define SWISSTM_CONSTANTS_H_

// this constant is useful for defining various data structures
#define MAX_THREADS 32

// size of a cache line in 4 byte words
#define CACHE_LINE_SIZE 16

// the smallest timestamp used
#define MINIMUM_TS 0

// top level transaction
#define TX_TOP_LEVEL 0
#define TX_NO_LEVEL (TX_TOP_LEVEL - 1)

namespace lpdstm {
	enum OperationType {
		NO_OP = 0,
		READ_OP = 1,
		WRITE_OP = 2,
		DELETE_OP = 3
	};

	inline char *getOperationName(OperationType optype) {
		char *names[] = {
			"noop",
			"read",
			"write",
			"delete"
		};

		return names[optype];
	}
}

#endif
