/**
 * Object implementation specific to final version of SwissTM.
 * 
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 */

#include "common/version_lock.h"
#include "memory.h"
#include "common/bitset.h"

namespace swisstm {

	struct ObjectHandleMixinvIRPrioT : public SwisstmTxAlloced {
		ObjectHandleMixinvIRPrioT(BaseObject *obj = NULL)
				: lock(get_version_lock(MINIMUM_TS + 1)),
				old_version(get_version_lock(MINIMUM_TS + 1)),
				current(obj), log(NULL) {
		}

		VersionLock lock;

		VersionLock old_version;

		BaseObject *current;

		BaseObject *log;

		// visible readers
		//Bitset reader_set;

	}  __attribute__ ((aligned (64)));
}
