/**
 * Definition of public interface of SwissTM.
 * 
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 */

#include "swisstm.h"


void swisstm::global_init() {
	init_tid_generator();

	global_init_mem();

	GlobalInitObjectHandle();

	CurrentTransaction::GlobalInit();
}

void swisstm::thread_init() {
	init_thread_tid();

	init_thread_mem();

	ThreadInitObjectHandle();

	CurrentTransaction::ThreadInit();
}

void swisstm::start_tx() {
	mem_tx_start();
	CurrentTransaction::TxStart();
}

void swisstm::commit_tx() {
	CurrentTransaction::TxCommit();
	mem_tx_commit();
}

void swisstm::abort_tx() {
	CurrentTransaction::TxAbort();
	mem_tx_abort();
}

void swisstm::abort_tx_full() {
	CurrentTransaction::TxAbortFull();
	mem_tx_abort();
}

#ifdef SUPPORT_NESTING
void swisstm::start_tx_nested() {
	CurrentTransaction::TxStart();
}

void swisstm::commit_tx_nested() {
	CurrentTransaction::TxCommit();
}

void swisstm::abort_tx_nested() {
	CurrentTransaction::TxAbort();
}
#else
void swisstm::start_tx_nested() {
	// do nothing
}

void swisstm::commit_tx_nested() {
	// do nothing
}

void swisstm::abort_tx_nested() {
	// do nothing
}
#endif
