/**
 * Definition of thread identifier generator.
 * 
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 */

#include <pthread.h>

#include "tid.h"
#include "common/atomic.h"

static swisstm::CounterOF counter;

::pthread_key_t swisstm::tid_key;

void swisstm::init_tid_generator() {
	::pthread_key_create(&tid_key, NULL);
}

void swisstm::init_thread_tid() {
	::pthread_setspecific(tid_key, (const void *)counter.getNext());
}

unsigned swisstm::get_thread_count() {
	return counter.getMax();
}
