/**
 * Declaration of elements required for thread identifier management.
 * 
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 */

#ifndef SWISSTM_TID_H_
#define SWISSTM_TID_H_

#include <pthread.h>

namespace swisstm {
	void init_tid_generator();

	void init_thread_tid();

	unsigned get_tid();

	unsigned get_thread_count();

	extern ::pthread_key_t tid_key;
}

inline unsigned swisstm::get_tid() {
	return (unsigned)::pthread_getspecific(tid_key);
}

#endif
