/**
 * Base transaction implementation.
 * 
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 */

#ifndef SWISSTM_TRANSACTION_BASE_H_
#define SWISSTM_TRANSACTION_BASE_H_

#include "constants.h"
#include "transaction_mixinv_ir_prio_t_base.h"

namespace swisstm {
	typedef TxMixinvIRPrioTBase TransactionBase;
}

namespace swisstm {
	extern TransactionBase *global_transaction_table[MAX_THREADS];

	inline void register_transaction(int id, TransactionBase *transaction) {
		global_transaction_table[id] = transaction;
	}

	inline TransactionBase *get_transaction(int id) {
		return global_transaction_table[id];
	}
}

#endif // SWISSTM_TRANSACTION_BASE_H_
